![Build](https://github.com/feko006/generictabletoprpg/actions/workflows/build-and-test.yml/badge.svg)

# generictabletoprpg

This is an app that helps you quickly access your dungeonmastersvault data via your Android device.
It can also help you track various things (see below).

[<img src="https://fdroid.gitlab.io/artwork/badge/get-it-on.png"
alt="Get it on F-Droid"
height="80">](https://f-droid.org/packages/com.feko.generictabletoprpg/)

Or download the latest APK from
the [Releases Section](https://github.com/feko006/generictabletoprpg/releases/latest).

## Table of Contents

- [Features](#features)
    - [DMV Import](#dmv-import)
    - [Tracker](#tracker)
        - [Supported Types](#supported-types)
        - [Long Rest](#long-rest)
    - [Encounters](#encounters)
    - [Own Your Data](#own-your-data)
- [Disclaimers](#disclaimers)
- [License](#license)

## Features

### DMV Import

Import your DMV (dungeonmastersvault.com) content as a json file and make it accessible on your
mobile device.
Your actions, armor, conditions, diseases, feats, spells and weapons will be imported in the app.
Use the Index to search everywhere. You can also search everywhere from the tracker.

<details>
    <summary>See it in action...</summary>
	<img src="readme-assets/dmv-import-showcase.gif" height="500" style="border-radius: 20px;" />
</details>

### Tracker

Track various things for your character, world, NPC, monster or whatever you can creatively think of
with a generic tracker.

#### Supported Types

- Arbitrary percentage
- HP + temporary HP too!
- Abilities
- Spell slots
- Arbitrary number, e.g. for gold, arrows...
- Known & prepared spells + more
- Text e.g. for notes, items...
- Hit dice
- Stats :new:

More types will be supported in the future.

#### Long Rest

Refreshes some of the tracked things like HP, spell slots...

<details>
    <summary>See it in action...</summary>
	<img src="readme-assets/long-rest-showcase.gif" height="500" style="border-radius: 20px;" />
</details>

### Encounters

Avoid a part of the tediousness of combat with the encounter tracker. Track initiative, lair
actions, HP, legendary actions and more! Mark entries as favorites and reset the encounter for
starting a new one.

<details>
    <dummary>See it in action...</dummary>
    <img src="readme-assets/encounters-showcase.gif" height="500" style="border-radius: 20px;" />
</details>

### Own Your Data

Export your data, store it wherever you want, share it to your friends, or import it in case you
install the app on a new device.

<details>
    <summary>See it in action...</summary>
	<img src="readme-assets/export-import-showcase.gif" height="500" style="border-radius: 20px;" />
</details>

## Disclaimers

- This app is not affiliated with *WotC* or *The Dungeon Master's Vault*.

## License

GPL-3.0 - GNU General Public License v3.0

See [LICENSE.md](LICENSE.md) file.
